# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::TimeSeriesInsights::Mgmt::V2018_08_15_preview
  module Models
    #
    # Parameters supplied to the Update Environment operation to update a
    # long-term environment.
    #
    class LongTermEnvironmentUpdateParameters < EnvironmentUpdateParameters

      include MsRestAzure

      # @return [LongTermStorageConfigurationMutableProperties] The storage
      # configuration provides the connection details that allows the Time
      # Series Insights service to connect to the customer storage account that
      # is used to store the environment's data.
      attr_accessor :storage_configuration

      # @return [Duration] ISO8601 timespan specifying the number of days the
      # environment's events will be available for query from the warm store.
      attr_accessor :data_retention


      #
      # Mapper for LongTermEnvironmentUpdateParameters class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'LongTermEnvironmentUpdateParameters',
          type: {
            name: 'Composite',
            class_name: 'LongTermEnvironmentUpdateParameters',
            model_properties: {
              tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tags',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              storage_configuration: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.storageConfiguration',
                type: {
                  name: 'Composite',
                  class_name: 'LongTermStorageConfigurationMutableProperties'
                }
              },
              data_retention: {
                client_side_validation: true,
                required: true,
                serialized_name: 'properties.warmStoreConfiguration.dataRetention',
                type: {
                  name: 'TimeSpan'
                }
              }
            }
          }
        }
      end
    end
  end
end
